package cz.agents.alite.vis3d.layer;

import com.jme3.scene.Spatial;
import java.util.List;
import cz.agents.alite.vis3d.Vis3d;

public abstract class AbstractVis3DLayer implements Vis3DLayer {

    @Override
    public void init(Vis3d vis) {
        List<Spatial> spatials = createSpatials(vis);
        if (spatials != null) {
            for (Spatial s : spatials) {
                registerToVis(vis, s);
            }
        }
    }

    protected abstract void registerToVis(Vis3d vis, Spatial s);

    protected abstract List<Spatial> createSpatials(Vis3d vis);
}
