package cz.agents.alite.vis3d.layer;

import com.jme3.math.Vector2f;
import com.jme3.scene.Spatial;
import com.jme3.ui.Picture;
import java.util.ArrayList;
import java.util.List;
import cz.agents.alite.vis3d.Vis3d;

public class Logo3DLayer extends AbstractVis3DLayer {

    private static final Vector2f DEFAULT_OFFSET = new Vector2f(10, 10);
    private Vector2f logoDim;
    private Vector2f offset;
    private String assetPath;

    private Logo3DLayer(String assetPath, Vector2f logoDim, Vector2f offset) {
        super();
        this.logoDim = logoDim;
        this.assetPath = assetPath;
        this.offset = offset;
    }

    public static Logo3DLayer create(String assetPath, Vector2f logoDim) {
        return new Logo3DLayer(assetPath, logoDim, DEFAULT_OFFSET);
    }

    public static Logo3DLayer create(String assetPath, Vector2f logoDim, Vector2f offset) {
        return new Logo3DLayer(assetPath, logoDim, offset);
    }

    @Override
    protected List<Spatial> createSpatials(Vis3d vis) {
        List<Spatial> ret = new ArrayList<Spatial>();
        Picture p = new Picture("logo");

        p.setWidth(logoDim.x);
        p.setHeight(logoDim.y);
        p.setImage(vis.getAssetManager(), assetPath, true);
        Vector2f screenDim = vis.getDisplayDimension();
        p.setLocalTranslation(screenDim.x - logoDim.x - offset.x, screenDim.y - logoDim.y - offset.y, 0);
        ret.add(p);
        return ret;
    }

    @Override
    protected void registerToVis(Vis3d vis, Spatial s) {
        vis.registerToGuiNode(s);
    }
}
