package tacv.universe;

import cz.agents.alite.common.entity.Entity;
import cz.agents.alite.communication.directory.DirectoryFacilitator;
import cz.agents.alite.simulation.Simulation;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Random;
import tacv.universe.entity.car.AbstractCarAgent;
import tacv.universe.entity.embodiment.AutomaticRegularCar;
import tacv.universe.environment.AgentScoutEnvironment;
import tacv.util.Point;

public class AgentScoutUniverse {

    private Map<String, Entity> entities = new LinkedHashMap<String, Entity>();
    private DirectoryFacilitator directoryFacilitator;
    
    private Simulation simulation;
    private AgentScoutEnvironment environment;


    public AgentScoutUniverse() {
        directoryFacilitator = new DirectoryFacilitator();
    }


    public DirectoryFacilitator getDirectoryFacilitator() {
        return directoryFacilitator;
    }


    public Simulation getSimulation() {
        return simulation;
    }

    public void setSimulation(Simulation simulation) {
        this.simulation = simulation;
    }

    public void setEnvironment(AgentScoutEnvironment environment) {
        this.environment = environment;
    }

    public AgentScoutEnvironment getEnvironment() {
        return environment;
    }

    public Random getRandom() {
        return environment.getRandom();
    }

//    public void addHelicopterAgent(String name, Team team, Point waypoint) {
//        HelicopterAgent helicopterAgent = new HelicopterAgent(name, map, environment.handler());
//        entities.put(name, helicopterAgent);
//
//        addHelicopterToStorage(name, team, waypoint);
//    }
//
//    private void addHelicopterToStorage(String name, Team team, Point position) {
//        environment.getHelicopterStorage().addHelicopter(new Skeldar(name, team, position));
//    }
        
    public void addCarAgent(AbstractCarAgent carAgent, Point position) {
        entities.put(carAgent.getName(), carAgent);
        addCarToStorage(carAgent.getName(), position);
    }
    
    private void addCarToStorage(String name, Point position) {
        environment.getCarStorage().addCar(new AutomaticRegularCar(name, position));
    }
//
//    public void addPersonAgent(String name, Team team, StreetGraphNode mapPosition) {
//        PersonAgent personAgent = new PersonAgent(name, map, environment.handler());
//        entities.put(name, personAgent);
//
//        addPersonToStorage(name, team, mapPosition);
//
//        VisManager.registerLayer(VisualPolicyLayer.create(personAgent, environment.getPersonStorage(), Color.RED, 3));
//    }
//
//    public void addSTAgent(String name, Team team, StreetGraphNode mapPosition) {
//        assert team == Team.ALLY || team == Team.FOE;
//
//        int iTeamID = (team == Team.ALLY ? 0 : 1);
//        PersonAgent personAgent = ExpSettings.createSTAgent(name, map, environment.handler(), iTeamID);
//        entities.put(name, personAgent);
//
//        addPersonToStorage(name, team, mapPosition);
//        VisManager.registerLayer(VisualPolicyLayer.create(personAgent, environment.getPersonStorage(), Color.RED, 3));
//    }
//
//    public void addObedientPersonAgent(String name, Team team, StreetGraphNode mapPosition) {
//        PersonAgent personAgent = new ObedientPersonAgent(name, map, environment.handler());
//        entities.put(name, personAgent);
//
//        addPersonToStorage(name, team, mapPosition);
//    }
//
//    public void addObedientAirplaneAgent(String name, Team team, OrientedPoint mapPosition) {
//        AirplaneAgent airplaneAgent = new ObedientAirplaneAgent(name, map, environment.handler());
//        entities.put(name, airplaneAgent);
//
//        addAirplaneToStorage(name, team, mapPosition);
//        VisManager.registerLayer(VisualPolicyLayer.create(airplaneAgent, environment.getAirplaneStorage(), Color.RED, 3, true, map));
//    }
//
//    public void addSTVisPlane(String name, Team team, OrientedPoint mapPosition) {
//        AirplaneAgent airplaneAgent = new STVisPlane(name, map, environment.handler(), 0);
//        entities.put(name, airplaneAgent);
//
//        addAirplaneToStorage(name, team, mapPosition);
//        VisManager.registerLayer(VisualPolicyLayer.create(airplaneAgent, environment.getAirplaneStorage(), Color.RED, 3, true, map));
//    }
//
//    public void addAllyTacticalAgent(String name, Team team, Point position, Vector direction) {
//        addPersonToTacticalStorage(name, team, position, direction);
//        TacticalAgent planningAgent = new AllyTacticalAgent(name, map, environment.handler(), new OrientedPoint(position, direction));
//        entities.put(name, planningAgent);
//    }
//
//    public void addJazzykAllySoldierAgent(String name, StreetGraphNode spawnNode, StreetGraphNode spawnTurnToNode, OrientedPoint position, char squadPos) {
//        addPersonToTacticalStorage(name, Team.ALLY, position, position.orientation);
//        TacticalAgent planningAgent = new JazzykAllySoldierAgent(name, map, environment.handler(), spawnNode, spawnTurnToNode, position, squadPos);
//        entities.put(name, planningAgent);
//    }
//
//    public void addJazzykAllyLeaderAgent(String name, StreetGraphNode spawnNode, StreetGraphNode spawnTurnToNode, OrientedPoint position, char squadPos) {
//        addPersonToTacticalStorage(name, Team.ALLY, position, position.orientation);
//        TacticalAgent planningAgent = new JazzykAllyLeaderAgent(name, map, environment.handler(), spawnNode, spawnTurnToNode, position, squadPos);
//        entities.put(name, planningAgent);
//    }
//
//    public void addInteractiveJazzykAllyLeaderAgent(String name, StreetGraphNode spawnNode, StreetGraphNode spawnTurnToNode, OrientedPoint position, char squadPos) {
//        addPersonToTacticalStorage(name, Team.ALLY, position, position.orientation);
//        TacticalAgent planningAgent = new InteractiveJazzykLeaderAgent(name, map, environment.handler(), spawnNode, spawnTurnToNode, position, squadPos);
//        entities.put(name, planningAgent);
//
//        VisManager.registerLayer(VisualInteractionLayer.create(planningAgent));
//    }
//
//    public void addJazzykAllyLeaderCarAgent(String name, StreetGraphNode spawnNode, StreetGraphNode spawnTurnToNode, OrientedPoint position, char squadPos) {
//        addPersonToTacticalStorage(name, Team.ALLY, position, position.orientation);
//        TacticalAgent planningAgent = new JazzykAllyLeaderAgent(name, map, environment.handler(), spawnNode, spawnTurnToNode, position, squadPos);
//        entities.put(name, planningAgent);
//    }
//
//    public void addJazzykAllyLeaderCarAgent(String name, String driverName, StreetGraphNode spawnNode, StreetGraphNode spawnTurnToNode, OrientedPoint position, char squadPos) {
//        JazzykLeaderCarAgent agent = new JazzykLeaderCarAgent(name, driverName, map, environment.handler(), spawnNode, spawnTurnToNode, position, squadPos);
//        entities.put(name, agent);
//
//        addCarToStorage(name, Team.ALLY, position, null, null);
//    }
//
//    public void addJazzykFoeAgent(String name, StreetGraphNode spawnNode, StreetGraphNode spawnTurnToNode, OrientedPoint position) {
//        addPersonToTacticalStorage(name, Team.FOE, position, position.orientation);
//        TacticalAgent planningAgent = new JazzykFoeAgent(name, map, environment.handler(), spawnTurnToNode, spawnTurnToNode, position);
//        entities.put(name, planningAgent);
//    }
//
//    public void addFoeTacticalAgent(String name, Team team, Point position, Vector direction) {
//        addPersonToTacticalStorage(name, team, position, direction);
//        TacticalAgent planningAgent = new FoeTacticalAgent(name, map, environment.handler(), new OrientedPoint(position, direction));
//        entities.put(name, planningAgent);
//    }
//
//    public void addAirplaneAgent(String name, Team team, OrientedPoint graphVertex) {
//        AirplaneAgent airplaneAgent = new AirplaneAgent(name, map, environment.handler());
//        entities.put(name, airplaneAgent);
//
//        addAirplaneToStorage(name, team, graphVertex);
//        VisManager.registerLayer(VisualPolicyLayer.create(airplaneAgent, environment.getAirplaneStorage(), Color.RED, 3, true, map));
//    }
//
//    public void addPatConvoyAgent(String name, Team team, StreetGraphNode mapPosition, int[] path) {
//        PatConvoyAgent carAgent = new PatConvoyAgent(name, map, environment.handler());
//        entities.put(name, carAgent);
//        carAgent.setPath(path);
//        addPersonToStorage(name, team, mapPosition);
//
//        VisManager.registerLayer(VisualPolicyLayer.create(carAgent, environment.getPersonStorage(), Color.RED, 3));
//    }
//
//    public void addPatPatrollerAgent(String name, Team team, OrientedPoint graphVertex,HashMap<Point, Double> patrollerRepulsiveMap, AlgorithmType alg) {
//        PatPatrollerAgent aeroAgent = new PatPatrollerAgent(name, map, environment.handler(),patrollerRepulsiveMap, alg);
//        entities.put(name, aeroAgent);
//
//        addAirplaneToStorage(name, team, graphVertex);
//    }
//
//    public void addPatAttackerAgent(String name, Team team, StreetGraphNode mapPosition, HashMap<Point, Double> patrollerRepulsiveMap, HashMap<Point, Double> convoyattractiveMap) {
//        PatAttackerAgent carAgent = new PatAttackerAgent(name, map, environment.handler(), patrollerRepulsiveMap, convoyattractiveMap);
//        entities.put(name, carAgent);
//
//        addPersonToStorage(name, team, mapPosition);
//
//        VisManager.registerLayer(VisualPolicyLayer.create(carAgent, environment.getPersonStorage(), Color.RED, 3));
//    }
//
//    public void addPatHelicopterAgent(String name, Team team, Point waypoint, HashMap<Point, Double> patrollerRepulsiveMap, AlgorithmType alg) {
//        PatPatrollerHelicopterAgent helicopterAgent = new PatPatrollerHelicopterAgent(name, map, environment.handler(),patrollerRepulsiveMap, alg);
//        entities.put(name, helicopterAgent);
//
//        addHelicopterToStorage(name, team, waypoint);
//    }
//
//    public void addPatExperimentAgent(String name) {
//        PatExperimentResultsAgent patera = new PatExperimentResultsAgent(name, map, environment.handler());
//        entities.put(name, patera);
//    }
//
//    public void addQuadrotorPlanningAgent(String name, Team team, OrientedPoint positionRotation) {
//        addQuadrotorToStorage(name, team, positionRotation);
//
//        QuadrotorPlanningAgent agent = new QuadrotorPlanningAgent(name, map, environment.handler());
//        entities.put(name, agent);
//
//        VisManager.registerLayer(VisualPlanLayer.create(agent.getOriginalPlanProvider(), environment.getQuadrotorStorage(), Color.WHITE, 2));
//        VisManager.registerLayer(VisualPlanLayer.create(agent, environment.getQuadrotorStorage(), Color.YELLOW, 5));
//    }
//
//    public void addHelicopterPlanningAgent(String name, Team team, OrientedPoint initialPosition) {
//        HelicopterPlanningAgent agent = new HelicopterPlanningAgent(name, map, environment.handler());
//        entities.put(name, agent);
//
//        addHelicopterToStorage(name, team, initialPosition);
//
//        VisManager.registerLayer(VisualPlanLayer.create(agent.getOriginalPlanProvider(), environment.getQuadrotorStorage(), Color.WHITE, 2));
//        VisManager.registerLayer(VisualPlanLayer.create(agent, environment.getQuadrotorStorage(), Color.YELLOW, 5));
//    }
//
//
//    public void addCarPlanningAgent(String name, Team team, OrientedPoint initialPosition) {
//        CarPlanningAgent agent = new CarPlanningAgent(name, map, environment.handler());
//        entities.put(name, agent);
//
//        addCarToStorage(name, team, initialPosition, null, null);
//
//        VisManager.registerLayer(VisualPlanLayer.create(agent.getOriginalPlanProvider(), environment.getQuadrotorStorage(), Color.WHITE, 2));
//        VisManager.registerLayer(VisualPlanLayer.create(agent, environment.getQuadrotorStorage(), Color.YELLOW, 5));
//    }

    public void start() {
        simulation.run();
    }
//    private void addPersonToStorage(String name, Team team, StreetGraphNode mapPosition) {
//        environment.getPersonStorage().addPerson(new Person(name, team, mapPosition, mapPosition, null));
//    }
//
//    private void addPersonToTacticalStorage(String name, Team team, Point position, Vector direction) {
//        environment.getTacticalPersonStorage().addPerson(new TacticalPerson(name, team, position, direction, null, null));
//    }
//
//    private void addAirplaneToStorage(String name, Team team, OrientedPoint graphVertex) {
//        environment.getAirplaneStorage().addAirplane(new Airplane(name, team, graphVertex, graphVertex));
//    }
//
//    private void addQuadrotorToStorage(String name, Team team, OrientedPoint positionRotation) {
//        environment.getQuadrotorStorage().addQuadrotor(new Quadrotor(name, team, positionRotation));
//    }
//
//    public boolean isPersonVisibleByAllies(String personName) {
//        Collection<TacticalPerson> allies = environment.getTacticalPersonStorage().getPersonsByTeam(Team.ALLY);
//
//        TacticalPerson person = environment.getTacticalPersonStorage().getPersons().get(personName);
//        for(TacticalPerson ally : allies) {
//            boolean isPersonVisible = environment.getMap().getVisibility().isVisible(
//                    ally.position, person.position, TacticalPerson.VISIBILITY_RANGE);
//            if (isPersonVisible) {
//                return true;
//            }
//        }
//
//        Map<String, Quadrotor> quadrotors = environment.getQuadrotorStorage().getQuadrotors();
//        for(Quadrotor quadrotor : quadrotors.values()) {
//            boolean isPersonVisible = environment.getMap().getVisibility().isVisible(
//                    quadrotor.position, person.position, TacticalPerson.VISIBILITY_RANGE);
//            if (isPersonVisible) {
//                return true;
//            }
//        }
//
//
//        return false;
//    }
//
//    public void createCapturingSubScenario() {
//        if (!isCapturingSubScenarioCreated) {
//            isCapturingSubScenarioCreated = true;
//
//            // allied capturers
//            addSTAgent("neo_null", Team.ALLY, getMap().getStreetGraph().getNearestNode(new Point(860, 610, 0)));
//            addObedientPersonAgent("slave1_null", Team.ALLY, getMap().getStreetGraph().getNearestNode(new Point(920, 584, 0)));
//
//            // foe elusive
//            addSTAgent("smith_null", Team.FOE, getMap().getStreetGraph().getNearestNode(new Point(820, 610, 0)));
//
//            HashSet<String> entityNames = new HashSet<String>();
//            entityNames.add("neo_null");
//            entityNames.add("slave1_null");
//            entityNames.add("smith_null");
//
//            // 2D vis
//            VisManager.registerLayer(PersonLayer.create(getEnvironment().getPersonStorage(), entityNames, Color.CYAN, Color.ORANGE));
//
//            // 3D vis
//            Vis3DManager.registerLayer(Person3DLayer.create(getEnvironment().getPersonStorage(), null, entityNames, Color.CYAN, Color.ORANGE, Team.ALLY, Team.FOE));
//        }
//    }
//
//    public void setLeaderAgentName(String leaderAgentName) {
//        this.leaderAgentName = leaderAgentName;
//    }
//
//    public void setLeadersTarget(StreetGraphNode node, StreetGraphNode turnTo) {
//        InteractiveJazzykLeaderAgent leader = (InteractiveJazzykLeaderAgent) this.entities.get(this.leaderAgentName);
//        leader.setTarget(node, turnTo);
//    }
//
//    public String getLeaderAgentName() {
//        return leaderAgentName;
//    }
}
