package tacv.universe.entity.car;

import tacv.universe.environment.AgentScoutEnvironment.AgentScoutEnvironmentHandler;
import tacv.universe.environment.actuator.GoToWaypointCarActuator;
import tacv.universe.environment.sensor.callback.WaypointReachedCallback;
import tacv.util.Point;

public abstract class WaypointCarAgent extends AbstractCarAgent {

    private final GoToWaypointCarActuator goToWaypointCarActuator;

    public WaypointCarAgent(final String name, final AgentScoutEnvironmentHandler handler) {
        super(name, handler);
        goToWaypointCarActuator = this.handler.addAction(GoToWaypointCarActuator.class, this);
        registerSensingResponse();
        handler.getCollisionZone();
    }

    private void registerSensingResponse() {
        carSensor.registerWaypointReachedCallback(new WaypointReachedCallback() {
            @Override
            public void waypointReached(Point wayPoint) {
                Point position = carSensor.senseMyPosition();
                WaypointCarAgent.this.waypointReached(wayPoint, position);
            }
        });
    }

    protected void actGoToWaypoint(Point waypoint) {
        goToWaypointCarActuator.actGoToWaypoint(waypoint, TARGET_SPEED, true);
    }
    
    protected void actHalt() {
        goToWaypointCarActuator.actHalt();
    }
    
    protected abstract void waypointReached(Point wayPoint, Point position);
}
