package tacv.vis;

import tacv.util.Point;
import cz.agents.alite.vis.element.Line;
import cz.agents.alite.vis.element.aggregation.LineElements;
import cz.agents.alite.vis.element.implemetation.LineImpl;
import cz.agents.alite.vis.layer.VisLayer;
import cz.agents.alite.vis.layer.common.CommonLayer;
import cz.agents.alite.vis.layer.terminal.LineLayer;
import java.awt.Color;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import tacv.universe.environment.storage.PositionedEntityStorage;

public class VisualPlanLayer extends CommonLayer {

    public static VisLayer create(final VisualPlanProvidingEntity entity, PositionedEntityStorage storage,
            final Color color, final int strokeWidth) {
        PositionedEntityToggleLayer toggle = PositionedEntityToggleLayer.create(entity.getName(), storage);

        toggle.addSubLayer(LineLayer.create(new LineElements() {

            @Override
            public Iterable<? extends Line> getLines() {
                ArrayList<Line> lines = new ArrayList<Line>();

                VisualPlan visualPlan = entity.getVisualPlan();
                Point oldPosition = null;
                for (Point position : visualPlan) {
                    if (oldPosition != null) {
                        LineImpl lineImpl = new LineImpl(oldPosition, position);
                        lines.add(lineImpl);
                    }
                    oldPosition = position;
                }

                return lines;
            }

            @Override
            public Color getColor() {
                return color;
            }

            @Override
            public int getStrokeWidth() {
                return strokeWidth;
            }
        }));

        return toggle;
    }

    public static interface VisualPlanProvidingEntity {

        public String getName();

        public VisualPlan getVisualPlan();
    }

    public static class VisualPlan extends LinkedList<Point> {

        public VisualPlan(List<Point> positions) {
            super(positions);
        }
        private static final long serialVersionUID = 6769212106194760839L;
    }
}
