package tacv.vis3d.layer;

import com.jme3.scene.Node;
import com.jme3.scene.Spatial;
import com.jme3.scene.Spatial.CullHint;
import cz.agents.alite.vis3d.Vis3d;
import cz.agents.alite.vis3d.control.PhysicalBodyControl;
import cz.agents.alite.vis3d.control.WheelsControl;
import cz.agents.alite.vis3d.layer.Chaseable3DLayer;
import cz.agents.alite.vis3d.layer.Vis3DLayer;
import java.util.ArrayList;
import java.util.List;
import tacv.universe.entity.embodiment.AutomaticRegularCar;
import tacv.universe.environment.storage.CarStorage;
import tacv.universe.world.Terrain;
import tacv.vis3d.generator.PathVisualization;
import tacv.vis3d.model.BulletCarPhysicalModelAdapter;
import tacv.vis3d.spatial.PathVisualizationControl;
import tacv.vis3d.spatial.TruckProvider;

public class Car3DLayer {

    public static Vis3DLayer create(final CarStorage carStorage, final Terrain terrain) {
        return new Chaseable3DLayer() {

            @Override
            protected List<Spatial> createSpatials(final Vis3d vis) {
                List<Spatial> ret = new ArrayList<Spatial>();
                for (final AutomaticRegularCar carOrigin : carStorage.getCars().values()) {
                    BulletCarPhysicalModelAdapter truckModel = new BulletCarPhysicalModelAdapter(carOrigin);
                    final Node next = TruckProvider.getInstance(vis).getNext(
                            carOrigin.getName(),
                            new PhysicalBodyControl(truckModel),
                            new WheelsControl(truckModel));
                    ret.add(next);
                    // plan of the car
                    // TODO: use provider
                    PathVisualization pathVisualization = new PathVisualization(terrain);
                    Node node = new Node();
                    node.addControl(new PathVisualizationControl(vis, pathVisualization, node, next, carOrigin));
                    node.setCullHint(CullHint.Never);
                    ret.add(node);
                }
                return ret;
            }
        };
    }
}
